Debian Bug report logs - #230990
5th button (mouse wheel) support

Package: ncurses; Maintainer for ncurses is Craig Small <csmall@debian.org>;

Reported by: Daniel Burrows <dnb114@psu.edu>

Date: Tue, 3 Feb 2004 20:18:01 UTC

Severity: wishlist

Tags: help

Merged with 476394

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Daniel Jacobowitz <ncurses-maint@debian.org>:
Bug#230990; Package libncurses5-dev. Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dnb114@psu.edu>:
New Bug report received and forwarded. Copy sent to Daniel Jacobowitz <ncurses-maint@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dnb114@psu.edu>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: 5th button (mouse wheel) support
Date: Tue, 3 Feb 2004 15:06:45 -0500
Package: libncurses5-dev
Version: 5.3.20030719-5
Severity: wishlist

  It would be nice if the ncurses mouse API could be used to track wheel
events.  (reported in X11 as buttons 4/5)  At the moment, ncurses seems
to report all wheel events as button 4.

  Daniel

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)
Kernel: Linux 2.6.1
Locale: LANG=en_US, LC_CTYPE=en_US (ignored: LC_ALL set to en_US)

Versions of packages libncurses5-dev depends on:
ii  libc6-dev [libc-dev]      2.3.2.ds1-11   GNU C Library: Development Librari
ii  libncurses5               5.3.20030719-5 Shared libraries for terminal hand

-- no debconf information


-- 
/-------------------- Daniel Burrows <dburrows@debian.org> -------------------\
|                 Voodoo Programming: Things programmers do                   |
|                 that they know shouldn't work but they try                  |
|                 anyway, and which sometimes actually work,                  |
|                 such as recompiling everything.                             |
\---- Be like the kid in the movie!  Play chess! -- http://www.uschess.org ---/



Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Jacobowitz <ncurses-maint@debian.org>:
Bug#230990; Package libncurses5-dev. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <drow@false.org>:
Extra info received and forwarded to list. Copy sent to Daniel Jacobowitz <ncurses-maint@debian.org>. Full text and rfc822 format available.

Message #10 received at 230990@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <drow@false.org>
To: Daniel Burrows <dnb114@psu.edu>, 230990@bugs.debian.org
Subject: Re: Bug#230990: 5th button (mouse wheel) support
Date: Sun, 12 Jun 2005 11:20:20 -0400
On Tue, Feb 03, 2004 at 03:06:45PM -0500, Daniel Burrows wrote:
>   It would be nice if the ncurses mouse API could be used to track wheel
> events.  (reported in X11 as buttons 4/5)  At the moment, ncurses seems
> to report all wheel events as button 4.

FYI, the latest version of ncurses (uploading soon) does support this -
but it's disabled, because the change is binary incompatible.  The next
time we need a new SONAME for libncurses, I intend to enable this.

-- 
Daniel Jacobowitz
CodeSourcery, LLC



Blocking bugs of 455585 added: 230990 Request was from Josh Triplett <josh@freedesktop.org> to control@bugs.debian.org. (Tue, 11 Dec 2007 07:57:04 GMT) Full text and rfc822 format available.

Bug reassigned from package `libncurses5-dev' to `ncurses'. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 23 Jun 2008 10:48:03 GMT) Full text and rfc822 format available.

Forcibly Merged 230990 476394. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 23 Jun 2008 10:48:04 GMT) Full text and rfc822 format available.

Forcibly Merged 230990 418239 476394. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 23 Jun 2008 12:06:02 GMT) Full text and rfc822 format available.

Severity set to `wishlist' from `normal' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 23 Jun 2008 12:36:05 GMT) Full text and rfc822 format available.

Severity set to `wishlist' from `wishlist' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 23 Jun 2008 12:36:07 GMT) Full text and rfc822 format available.

Disconnected #418239 from all other report(s). Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Sat, 21 Jan 2012 17:12:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#230990; Package ncurses. (Sun, 22 Jan 2012 11:00:39 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Sun, 22 Jan 2012 11:00:45 GMT) Full text and rfc822 format available.

Message #29 received at 230990@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: 230990@bugs.debian.org
Subject: Changing libncurses SONAME
Date: Sun, 22 Jan 2012 11:58:49 +0100
tags 230990 + help
thanks

On 2005-06-12 17:20 +0200, Daniel Jacobowitz wrote:

> On Tue, Feb 03, 2004 at 03:06:45PM -0500, Daniel Burrows wrote:
>>   It would be nice if the ncurses mouse API could be used to track wheel
>> events.  (reported in X11 as buttons 4/5)  At the moment, ncurses seems
>> to report all wheel events as button 4.
>
> FYI, the latest version of ncurses (uploading soon) does support this -
> but it's disabled, because the change is binary incompatible.  The next
> time we need a new SONAME for libncurses, I intend to enable this.

Unfortunately, switching SONAME seems to be out of the question since
even after the introduction of libtinfo5 we still have dozens of
libraries linking against libncurses.  My feeble attempt¹ to fix a few
of them has not changed anything yet.

The only safe way to do this seems to be to introduce versioned symbols
in ncurses, and I don't know at all how to do that in a way which

a) is acceptable for upstream;

b) works correctly for all the bazillion configuration options that
   change the ABI, for instance "--enable-widec", "--enable-ext-colors",
   "--enable-ext-mouse", "--with-termlib=...", "--with-ticlib=..." etc.

In short, we're stuck with the current insane mishmash of
libncurses5/libncursesw5, and I have no idea how to ever get out of this
mess.

See also the thread starting at
http://lists.debian.org/debian-devel/2008/09/msg00435.html.

Sven


¹ http://bugs.debian.org/cgi-bin/pkgreport.cgi?users=ncurses@packages.debian.org;usertag=libncurses5-dependency




Added tag(s) help. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Sun, 22 Jan 2012 11:00:59 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#230990; Package ncurses. (Sun, 22 Jan 2012 21:39:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Small <csmall@debian.org>:
Extra info received and forwarded to list. (Sun, 22 Jan 2012 21:39:07 GMT) Full text and rfc822 format available.

Message #36 received at 230990@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: Sven Joachim <svenjoac@gmx.de>, 230990@bugs.debian.org
Subject: Re: Bug#230990: Changing libncurses SONAME
Date: Mon, 23 Jan 2012 08:30:23 +1100
On Sun, Jan 22, 2012 at 11:58:49AM +0100, Sven Joachim wrote:
> Unfortunately, switching SONAME seems to be out of the question since
> even after the introduction of libtinfo5 we still have dozens of
> libraries linking against libncurses.  My feeble attempt¹ to fix a few
> of them has not changed anything yet.
Is that all of them or only a small sample?  I wouldn't be too worried
yet Sven.  If I received a bug report similiar to yours I'd make the
change but would not think it important enough to release a new 
version of the dependent package.

You could always do what I did for libprocps and break all dependent
packages... hmmm perhaps not.

> In short, we're stuck with the current insane mishmash of
> libncurses5/libncursesw5, and I have no idea how to ever get out of this
> mess.
libtinfo is supposed to help here isn't it?

 - Craig

-- 
Craig Small VK2XLZ   http://enc.com.au/          csmall at : enc.com.au
Debian GNU/Linux     http://www.debian.org/      csmall at : debian.org
GPG fingerprint:     5D2F B320 B825 D939 04D2  0519 3938 F96B DF50 FEA5




Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#230990; Package ncurses. (Sun, 22 Jan 2012 22:12:23 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Sun, 22 Jan 2012 22:12:24 GMT) Full text and rfc822 format available.

Message #41 received at 230990@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Craig Small <csmall@debian.org>
Cc: 230990@bugs.debian.org
Subject: Re: Bug#230990: Changing libncurses SONAME
Date: Sun, 22 Jan 2012 23:09:59 +0100
On 2012-01-22 22:30 +0100, Craig Small wrote:

> On Sun, Jan 22, 2012 at 11:58:49AM +0100, Sven Joachim wrote:
>> Unfortunately, switching SONAME seems to be out of the question since
>> even after the introduction of libtinfo5 we still have dozens of
>> libraries linking against libncurses.  My feeble attempt¹ to fix a few
>> of them has not changed anything yet.
> Is that all of them or only a small sample?

It's only a small sample:

,----
| $ apt-cache rdepends libncurses5 | grep -E '(^  lib|-libs$)' | wc -l
| 52
`----

> You could always do what I did for libprocps and break all dependent
> packages... hmmm perhaps not.
>
>> In short, we're stuck with the current insane mishmash of
>> libncurses5/libncursesw5, and I have no idea how to ever get out of this
>> mess.
> libtinfo is supposed to help here isn't it?

It has certainly helped, but libncurses5 has still ~500 reverse
dependencies in unstable.  I'm eagerly awaiting "-Wl,--as-needed" to be
added to the default LDFLAGS…

Cheers,
       Sven




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#230990; Package ncurses. (Mon, 23 Jan 2012 20:09:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Small <csmall@debian.org>:
Extra info received and forwarded to list. (Mon, 23 Jan 2012 20:09:07 GMT) Full text and rfc822 format available.

Message #46 received at 230990@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: Sven Joachim <svenjoac@gmx.de>, 230990@bugs.debian.org
Subject: Re: Bug#230990: Changing libncurses SONAME
Date: Tue, 24 Jan 2012 07:04:56 +1100
On Sun, Jan 22, 2012 at 11:09:59PM +0100, Sven Joachim wrote:
> It has certainly helped, but libncurses5 has still ~500 reverse
> dependencies in unstable.  I'm eagerly awaiting "-Wl,--as-needed" to be
> added to the default LDFLAGS…
Of those 500, a fair proportion would need libnucrses. I believe procps
does and it needs both versions of libncurses dev packages.

There's no automatic way of working out if a package needs libtinfo
rather than libncurses?  It comes down to which functions it needs I
guess.
 - Craig

-- 
Craig Small VK2XLZ   http://enc.com.au/          csmall at : enc.com.au
Debian GNU/Linux     http://www.debian.org/      csmall at : debian.org
GPG fingerprint:     5D2F B320 B825 D939 04D2  0519 3938 F96B DF50 FEA5




Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#230990; Package ncurses. (Mon, 23 Jan 2012 21:06:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Mon, 23 Jan 2012 21:06:20 GMT) Full text and rfc822 format available.

Message #51 received at 230990@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Craig Small <csmall@debian.org>
Cc: 230990@bugs.debian.org
Subject: Re: Bug#230990: Changing libncurses SONAME
Date: Mon, 23 Jan 2012 22:03:48 +0100
On 2012-01-23 21:04 +0100, Craig Small wrote:

> On Sun, Jan 22, 2012 at 11:09:59PM +0100, Sven Joachim wrote:
>> It has certainly helped, but libncurses5 has still ~500 reverse
>> dependencies in unstable.  I'm eagerly awaiting "-Wl,--as-needed" to be
>> added to the default LDFLAGS…
> Of those 500, a fair proportion would need libnucrses. I believe procps
> does and it needs both versions of libncurses dev packages.

It would need some adoptions in the build system to link all programs in
the procps suite against ncursesw, I guess.

> There's no automatic way of working out if a package needs libtinfo
> rather than libncurses?

Build the package and look for dpkg-shlibdeps warnings:

dpkg-shlibdeps: warning: dependency on libncurses.so.5 could be avoided
if "/path/to/source/debian/foo/usr/bin/bar" were not uselessly linked
against it (they use none of its symbols).

If the same warning pops up for libtinfo.so.5, the binary should not be
linked against a curses or termlib library.  If there is no such warning
for libtinfo.so.5, then the binary could be linked against tinfo rather
than ncurses.

Cheers,
       Sven




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 04:05:18 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.